/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * Simple simulation of an SR-latch.  
 * Ben Moszkowski. 
 */
 
/* run */ define latch_test() = exists S,R,Q,Qbar: {
    S=false and R=false and Q=false and Qbar=false
    and for l in [[true,false],[false,false],[false,true],[true,false],[false,false]] do {
	len(5)
	and S gets l[0] and R gets l[1]
    }
    and Q gets not(R or Qbar)
    and Qbar gets not(S or Q)
    and format("%4S %3S  %3S  %3S\n","Qbar"," Q "," R "," S ")
    and always format("%3S  %3S  %3S  %3S\n",wave(Qbar),wave(Q),wave(R),wave(S))
}.

define wave(A) = {
    if A=false then "|  " else " | "
}.

